# File: BibNote.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.BibNotes.config import *

from Products.CMFCore.utils import getToolByName

from Products.BibNotes import BibNotesIndexes

from Products.BibNotes.interfaces.indexes import IBibNotesIndexes
from Products.BibNotes.interfaces.note import IBibNote

from Products.CMFCore.CMFCorePermissions import View

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    TextField(
        name='annotation',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
	    rows=20,
            label='Annotation',
            label_msgid='BibNotes_label_annotation',
            i18n_domain='BibNotes',
        ),
        default_output_type='text/html'
    ),

    IntegerField(
        name='bibnotesRecommend',
        widget=BooleanWidget(
            label='Recommend',
            label_msgid='BibNotes_label_bibnotesrecommend',
            i18n_domain='BibNotes',
        )
    ),


    IntegerField(
        name='bibnotesToRead',
        widget=BooleanWidget(
            label='Add to reading list',
            label_msgid='BibNotes_label_bibnotestoread',
            i18n_domain='BibNotes',
        )
    ),


    ReferenceField(
        name='references',
        widget=ReferenceWidget(
            label='References',
            label_msgid='BibNotes_label_references',
            i18n_domain='BibNotes',
        ),
        allowed_types=('Reference',),
        multiValued=0,
        relationship='bibnotes_references'
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BibNote_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BibNote(BaseContent,BibNotesIndexes):
    security = ClassSecurityInfo()

    ifaces = (getattr(BaseContent,'__implements__',()),)

    __implements__ = ifaces + (IBibNote,IBibNotesIndexes)

    # This name appears in the 'add' box
    archetype_name = 'BibNote'

    meta_type = 'BibNote'
    portal_type = 'BibNote'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    allow_discussion = False
    #content_icon = 'BibNote.gif'
    immediate_view = 'view'
    default_view = 'view'
    suppl_views = ()
    typeDescription = "BibNote"
    typeDescMsgId = 'description_edit_bibnote'

    schema = BibNote_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    # Manually created methods

    security.declarePublic('update')
    def update(self,target,annotation,bibnotesRecommend,bibnotesToRead):
        """
        Update a BibNote object.
        """
	self.addReference(target,relationship='bibnotes_references')
	
	schema = self.Schema()
	for fieldname in ('annotation','bibnotesRecommend','bibnotesToRead'):
	    field = schema.get(fieldname)
	    mutator = field.getMutator(schema)
	    mutator(eval(fieldname))
	reference_catalog = getToolByName(self,'reference_catalog')
	reference_catalog.catalog_object(self,'/'.join(self.getPhysicalPath()))
	self.reindexObject()
    
    security.declarePublic('bibnotesRefUID')
    def bibnotesRefUID(self):
	return self.id
	#
	# Now, this was silly
	#
	#refs = self.getRefs()
	#if refs:
	#    ref = refs[0].UID()
	#else:
	#    ref = None
	#return ref

    security.declarePublic('Authors')
    def Authors(self):
	refs = self.getRefs()
	if refs:
	    ret = refs[0].Authors()
	else:
	    ret = ''
	return ret

    # will this cause bad stuff to happen?
    security.declarePublic('Title')
    def Title(self):
	refs = self.getRefs()
	if refs:
	    ret = refs[0].Title()
	else:
	    ret = ''
	return ret

    # accessor-fu
    security.declarePublic('publication_year')
    def publication_year (self):
	refs = self.getRefs()
	if refs:
	    obj = refs[0]
	    ret = obj.Schema().getRawPublication_year()
	else:
	    ret = ''
	return ret

    security.declarePublic('Source')
    def Source(self):
	refs = self.getRefs()
	if refs:
	    ret = refs[0].Source()
	else:
	    ret = ''
	return ret

    security.declareProtected(View,'SearchableText')
    def SearchableText(self):
	authors = self.Authors().encode('utf8')
	title = self.Title().encode('utf8')
	source = self.Source().encode('utf8')
	year = self.publication_year().encode('utf8')
	return '%s %s %s %s' % (authors,
			        title,
			        year,
			        source
                            )
    
registerType(BibNote,PROJECTNAME)
# end of class BibNote

##code-section module-footer #fill in your manual code here
##/code-section module-footer
