from Products.CMFCore.utils import getToolByName
from DateTime import DateTime
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Products.CMFCore.CMFCorePermissions import View

from Products.Archetypes.utils import shasattr

class BibNotesIndexes:

    security = ClassSecurityInfo()

    #
    # Be paranoid about the existence of a UID for this
    # object.
    #
    def _maybe_get_uid(self):
	if shasattr(self,'UID') and self.UID:
	    uid = self.UID()
	else:
	    uid = 'bogus UID that will not find anything'
	return uid
	
    
    security.declareProtected(View,'bibnotesTotalNotes')
    def bibnotesTotalNotes(self):
	uid = self._maybe_get_uid()
	reference_catalog = getToolByName(self,'reference_catalog')
	hits = len(reference_catalog(targetUID=uid
	                           , bibnotesToRead=0
				   , relationship='bibnotes_references'
		))
	return hits
    
    security.declareProtected(View,'bibnotesTotalRecommends')
    def bibnotesTotalRecommends(self):
	uid = self._maybe_get_uid()
	reference_catalog = getToolByName(self,'reference_catalog')
	hits = len(reference_catalog(targetUID=uid
			           , relationship='bibnotes_references'
				   , bibnotesRecommend=1
		))
	return hits

    # This is used to extract a union of recommended readings lists
    # that contain this source from the catalog.
    #
    security.declareProtected(View,'bibnotesSomeReaders')
    def bibnotesSomeReaders(self):
	reference_catalog = getToolByName(self,'reference_catalog')
	uid = self._maybe_get_uid()
	res = reference_catalog(relationship='bibnotes_references'
			      , targetUID=self.UID()
			      , bibnotesRecommend=1)
	if res:
	    slice = [x.Creator for x in res[:6]]
	else:
	    slice = []
	return slice
    
    security.declareProtected(View,'bibnotesBuzzDate')
    def bibnotesBuzzDate(self):
	return DateTime()

    security.declarePublic('bibnotesRefUID')
    def bibnotesRefUID(self):
	return self.UID()

InitializeClass(BibNotesIndexes)
