from Interface import Interface

class IBibNotesIndexes(Interface):
    """ Indexing function attributes used by both the BibNote object
        and CMFBibliographyAT entry objects.
    """

    def bibnotesTotalNotes(self):
	""" The total number of user notes pointing at
	    the content item represented by my parent.
	"""

    def bibnotesTotalRecommends(self):
	""" The total number of user notes pointing at the
	    content item represented by my parent
	    that have the "Recommend" field toggle set.
	"""

    def bibnotesSomeReaders(self):
	""" A list of up to five user IDs, being readers who
	    have set the "Recommend" toggle for the content
	    item represented by my parent.
	"""
	
    def bibnotesBuzzDate(self):
	""" The most recent date on which a note pointing
	    at the content item represented by my parent has 
	    been edited or modified.
	"""

    def bibnotesRefUID(self):
	""" The UID of the content item represented by my
	    parent.
	"""

