from Interface import Interface, Attribute

class IBibNote(Interface):
    """ Methods provided by a note object.  Most of these
        just clone content from the target object.  They 
	exist only do pump data into the catalog, so that
	it can be retrieved later as part of a lazy list.
    """

    def update(self,target,annotation,bibnotesRecommend,bibnotesToRead):
	""" Update a BibNote object with fresh content, and
	    reindex it in both the reference catalog and the
	    portal catalog.
	"""
    
    def Authors(self):
	""" The content of the Authors field from the content
	    item that I represent.
	"""
	
    def Title(self):
	""" The content of the Title field from the content
	    item that I represent.
	"""
		
    def publication_year (self):
	""" The content of the publication_year field from the 
	    content item that I represent.
	"""
	
    def Source(self):
	""" The content of the Source field from the 
	    content item that I represent.
	"""
