## Controller Python Script "bibnotes_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Edit a bibliography annotation

# Grab the annotation, save the text and bibnotesRecommend
# toggle value in it, and reindex the object.

# Gather up the values for the edit
form = context.REQUEST.form
annotation = form.get('annotation')
text_format = form.get('annotation_text_format')

bibnotesRecommend = form.get('bibnotesRecommend','False')
if bibnotesRecommend in ('0','False'):
  bibnotesRecommend = False
else:
  bibnotesRecommend = True

bibnotesToRead = form.get('bibnotesToRead','False')
if bibnotesToRead in ('0','False'):
  bibnotesToRead = 0
else:
  bibnotesToRead = 1

# If we are annotating this source, drop it from our
# list of upcoming readings
if annotation:
  bibnotesToRead=0

ref = form.get('bibnotes_ref')

# Get the path to the object
stub = form.get('bibnotes_stub')
if not stub:
  state.set(status='failure',portal_status_message='Annotations can only be created using the "annotation" tab')
  return state

# Get the object itself
from Products.CMFCore.utils import getToolByName
portal_url = getToolByName(context,'portal_url')
root = portal_url.getPortalObject()
top = root.restrictedTraverse('bibnotes_data')
obj = top.restrictedTraverse(stub)

# Finalize object if we're creating and using the factory
if stub.split('/')[1] == 'portal_factory':
  new_obj = top.restrictedTraverse(stub).doCreate(obj)
else:
  new_obj = obj

# Edit! ... or Delete!  Maybe!
if annotation or bibnotesToRead:
    new_obj.update(target=context
                 , annotation=annotation
        	 , bibnotesRecommend=bibnotesRecommend
		 , bibnotesToRead=bibnotesToRead)
    
else:
    new_obj_id = new_obj.getId()
    new_obj = new_obj.aq_parent
    new_obj.manage_delObjects(new_obj_id)


# Bob's your uncle
state.set(status='success')
return state
