## Script (Python) "bibnotes_open"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Create an annotation object if necessary
##

#
# Welcome to the part of the product that isn't very pretty.
#
# This is the second of two initialization script run from within
# bibnotes_edit.pt.
#
# The annotation object is created using
# portal_factory, so that they don't hang around if
# the user navigates away from the annotation form.
# This potentially runs afoul of the 
# same traversal snafu, but since these are named
# using a prefixed version of the target object UID,
# a match with another object ID is pretty unlikely.
# It would be better, though, if portal_factory could
# be directed explicitly to create objects at
# arbitrary locations in the object hierarchy.

from Products.CMFPlone.utils import transaction_note
from Products.CMFCore.utils import getToolByName
from AccessControl import getSecurityManager
REQUEST = context.REQUEST

portal_url = getToolByName(context,'portal_url')
portal_root     = portal_url.getPortalObject()
obj_type        = context.getTypeInfo().getId()
obj_uid         = context.UID()
id              = obj_uid
username        = getSecurityManager().getUser().getUserName()

top = portal_root.restrictedTraverse('bibnotes_data')
userfolder=top.restrictedTraverse(username)

if not userfolder.has_key(id):
    stub = '%s/portal_factory/BibNote/%s' % (username,id)
    o = top.restrictedTraverse(stub)
    transaction_note('Initiated creation of %s with id %s in %s' % (o.getTypeInfo().getId(), id, o.absolute_url()))
else:
    stub = '%s/%s' % (username,id)
    o = userfolder.restrictedTraverse(id)

REQUEST.set('bibnotes_stub',stub)
REQUEST.set('bibnotes_ref',id)
if o is None:
    raise Exception


