## Script (Python) "bibnotes_search"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Wrapper script for some nice search functions
##

from Products.CMFCore.utils import getToolByName
from AccessControl import getSecurityManager

REQUEST = context.REQUEST
zcat = getToolByName(context,'portal_catalog')
username = getSecurityManager().getUser().getUserName()
bibnotes_data = getToolByName(context,'bibnotes_data')
userfolder = bibnotes_data.restrictedTraverse(username)

root = getToolByName(context,'portal_url').getPortalObject()
rootpath = '/'.join(root.getPhysicalPath())

mypath = '%s/bibnotes_data/%s' % (rootpath,username)

portal_bibliography=getToolByName(context,'portal_bibliography')
reference_types = portal_bibliography.getReferenceTypes()

BuzzTime = DateTime()-30

d = {}
d['selectonly'] = 'all'
d['sortby'] = 'alphabetical'
d['searchterm'] = ''

SESSION = REQUEST.SESSION
v = {}

searchterm = REQUEST.form.get('searchterm','')

refident = REQUEST.get('refident','')
if refident and not REQUEST.get('selectonly'):
    first_refident = 1
else:
    first_refident = None

for var in ['selectonly','sortby']:
    new_val = REQUEST.form.get(var,'')
    old_val = SESSION.get(var,'')
    if  new_val:
	if new_val != old_val:
	    SESSION.set(var,new_val)
    else:
	new_val = old_val
	if not new_val: new_val=d[var]
	REQUEST.set(var,new_val)
    v[var] = new_val
    
a = {}
a['publication_year'] = ('publication_year','descending')
a['alphabetical']     = ('Authors','ascending')
a['recommended']      = ('bibnotesTotalRecommends','descending')
a['annotated']        = ('bibnotesTotalNotes','descending')

if not v['sortby']: v['sortby']='alphabetical'

sort_on    = a[v['sortby']][0]
sort_order = a[v['sortby']][1]

# tuples to save typing
b = {}
b['myrecommends'] = ('BibNote',       mypath, 1,  '', '', '')
b['mynotes'] =      ('BibNote',       mypath, '', '', '', 0)
b['mylist'] =       ('BibNote',       mypath, '', '', '', 1)
b['all'] =          (reference_types, '',     '', '', '', '')
b['theunknown'] =   (reference_types, '',     '', 0,  '', '')
b['buzz'] =         (reference_types, '',     '', '', {'query':BuzzTime,
						       'range':'min'}, '')

if not v['selectonly']: v['selectonly']='all'

meta_type          = b[v['selectonly']][0]
path               = b[v['selectonly']][1]
bibnotesRecommend  = b[v['selectonly']][2]
bibnotesTotalNotes = b[v['selectonly']][3]
bibnotesBuzzDate   = b[v['selectonly']][4]
bibnotesToRead     = b[v['selectonly']][5]

# Finally, see if we're limiting the scope to a
# union of randomly selected reading lists.  See
# README.txt for info on how this is meant to work
bibnotesSomeReaders = ''


if refident:
    if first_refident:
	REQUEST.set('selectonly','all')
	meta_type=reference_types
	path=''
	bibnotesRecommend=''
	bibnotesTotalNotes=''
	bibnotesBuzzDate=''
	
    rcat = getToolByName(context,'reference_catalog')
    target = rcat.lookupObject(uuid=refident)
    bibnotesSomeReaders=target.bibnotesSomeReaders()
    authors = ''
    if target.Authors():
	authors = '%s, ' % (target.Authors(),)
    year = ''
    schema = target.Schema()
    field = schema.getField('publication_year')
    accessor = field.getAccessor(schema)
    publication_year = accessor()
    if publication_year:
    	year = ' (%s)' % (publication_year,)
	
    REQUEST.set('RefTitle','%s"%s"%s' % (authors,target.Title(),year))
#terms = '''
#         bibnotesRecommend: (%s) 
#         bibnotesTotalNotes: (%s)
#	 bibnotesSomeReaders: (%s)
#	 searchterm: (%s)
#	 meta_type: (%s)
#	 path: (%s)
#'''      % (bibnotesRecommend
#	   ,bibnotesTotalNotes
#	   ,bibnotesSomeReaders
#	   ,searchterm
#	   ,meta_type
#	   ,path)
#REQUEST.set('RefTitle',terms)
#REQUEST.set('refident',1)
	   
res = zcat(meta_type=meta_type
	 , path=path
	 , bibnotesRecommend=bibnotesRecommend
	 , bibnotesToRead=bibnotesToRead
	 , bibnotesTotalNotes=bibnotesTotalNotes
	 , bibnotesBuzzDate=bibnotesBuzzDate
	 , sort_on=sort_on
	 , sort_order=sort_order
	 , bibnotesSomeReaders=bibnotesSomeReaders
	 , sort_limit=1000
	 , SearchableText=searchterm)

return res
