import os, sys

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFPlone.tests.PloneTestCase import PloneTestCase
from Products.BibNotes.tests import setup



class TestBibNotesInstall(PloneTestCase):
    '''Test a BibNotes install'''

    ZopeTestCase._print('Will test integrity of the installation\n')
    
    def afterSetUp(self):
        pass

    # the individual tests
    
    def testToolInstall(self):
	st = self.portal
	self.failUnless('bibnotes_tool' in st.objectIds())
    
    def testDataFolderInstall(self):
	st = self.portal
	self.failUnless('bibnotes_data' in st.objectIds())
    
    def testSkinInstall(self):
	st = self.portal.portal_skins
	self.failUnless('BibNotes' in st.objectIds())
	
    def testTypeInstall(self):
	tt = self.portal.portal_types
	for t in ['BibNote','BibNotesTool','BibNotesFolder','BibNotesUser']:
	    self.failUnless(t in tt.objectIds(),'%s is not installed' % (t,))
    
    def testPortalIndexes(self):
        ctool = self.portal.portal_catalog

        pidx = []
	pidx.append('bibnotesTotalNotes')
	pidx.append('bibnotesTotalRecommends')
	pidx.append('bibnotesRecommend')
	pidx.append('bibnotesBuzzDate')
	pidx.append('bibnotesToRead')
	pidx.append('bibnotesSomeReaders')
	pidx.append('bibnotesRefUID')
	
        for idx in pidx:
            self.failUnless(idx in ctool.indexes(),'%s not in portal catalog' % (idx,))

    def testPortalCatalogMetadata(self):
        ctool = self.portal.portal_catalog

        pcol = []
	pcol.append('bibnotesTotalNotes')
	pcol.append('bibnotesTotalRecommends')
	pcol.append('bibnotesSomeReaders')
	
        for col in pcol:
            self.failUnless(col in ctool.schema(),'%s not in portal catalog metadata' % (col,))

    def testReferenceIndexes(self):
        ctool = self.portal.reference_catalog

        ridx = []
	ridx.append('bibnotesRecommend')
	ridx.append('bibnotesToRead')
	ridx.append('Creator')
	
        for idx in ridx:
            self.failUnless(idx in ctool.indexes(),'%s not in reference catalog' % (idx,))

    def testReferenceCatalogMetadata(self):
        ctool = self.portal.reference_catalog

        rcol = []
	rcol.append('bibnotesRecommend')
	rcol.append('bibnotesToRead')
	rcol.append('Creator')
	
        for col in rcol:
            self.failUnless(col in ctool.schema(),'%s not in reference catalog metadata' % (col,))

    #
    # Test the annotation tabs to pieces.
    #
    def testAnnotationTab(self):
	rt = self.portal.portal_bibliography.getReferenceTypes()
	for t in rt:
	    ti = self.portal.portal_types.getTypeInfo(t)
	    a = ti.getActionObject('object/annotate')
	    title = a.Title() == 'Annotate'
	    action = a.getActionExpression() == 'string:${object_url}/bibnotes_annotate'
	    condition = a.getCondition() == ''
	    permission = a.getPermissions() == ('View',)
	    visible = a.getVisibility() == 1
	    self.failUnless(a, 'no annotate tab on %s' % (t,))
	    self.failUnless(title, 'weird title for annotate tab on %s' % (t,))
	    self.failUnless(action, 'weird action string for action %s' % (t,))
	    self.failUnless(condition, 'weird condition for action %s' % (t,))
	    self.failUnless(permission, 'weird permission for action %s' % (t,))
	    self.failUnless(visible, 'weird visibility toggle for action %s' % (t,))

    def testDataArchiveNotToBeZapped(self):
	qi = self.portal.portal_quickinstaller
	self.failUnless('BibNotes' in qi.objectIds(),'dang, no product in QuickInstaller')
	olist = qi.BibNotes.getPortalObjects()
	self.failUnless('bibnotes_data' not in olist,'data folder will be clobbered by QuickInstaller upon uninstall')
	
	    
    # end of the individual tests

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestBibNotesInstall))
    return suite

if __name__ == '__main__':
    framework()
